using System;
using System.Drawing;
using Decal.Adapter.Support;
using Decal.Interop.Controls;

namespace Decal.Adapter.Wrappers;

public class StaticWrapper : ControlWrapperBase<StaticTextClass>
{
	private EventHandler<ControlEventArgs> evtDestroy;

	public string Text
	{
		get
		{
			return base.Control.Text;
		}
		set
		{
			base.Control.Text = value;
		}
	}

	public Color TextColor
	{
		get
		{
			return Util.ColorFromBGR(base.Control.TextColor);
		}
		set
		{
			base.Control.TextColor = Util.ColorToBGR(value);
		}
	}

	public event EventHandler<ControlEventArgs> Destroy
	{
		add
		{
			if (evtDestroy == null)
			{
				base.Control.Destroy += DestroyEvent;
			}
			evtDestroy = (EventHandler<ControlEventArgs>)Delegate.Combine(evtDestroy, value);
		}
		remove
		{
			evtDestroy = (EventHandler<ControlEventArgs>)Delegate.Remove(evtDestroy, value);
			if (evtDestroy == null)
			{
				base.Control.Destroy -= DestroyEvent;
			}
		}
	}

	protected override void Dispose(bool disposing)
	{
		if (disposing && evtDestroy != null)
		{
			evtDestroy = (EventHandler<ControlEventArgs>)Delegate.Remove(evtDestroy, evtDestroy);
			base.Control.Destroy -= DestroyEvent;
		}
		base.Dispose(disposing);
	}

	private void DestroyEvent(int ID)
	{
		if (evtDestroy != null)
		{
			evtDestroy(this, new ControlEventArgs(ID));
		}
	}
}
